/*
NOME: 0023_DENSTPO_EXPORTA_NF_ENTRADA_OFICIAL.SQL

DESCRIO: Procedimento para gerao das NFs de entrada em tabela para todas as filiais (exceto MACAE 1800).

CRIAO: 19/08/2008 - Fabrcio Marcelo da Silva

@C:\web_550\sql\end_conv\oracle\clientes\den\0023_DENSTPO_EXPORTA_NF_ENTRADA_OFICIAL.SQL

RAISE_APPLICATION_ERROR(-20501, '' , TRUE);
*/

CREATE OR REPLACE PROCEDURE EXPORTA_NF_ENTRADA_OFICIAL(
     P_DTINICIAL IN NOTAFISCAL.DTENTRSAID%TYPE,
     P_DTFINAL   IN NOTAFISCAL.DTENTRSAID%TYPE,
     P_IDFECHA   IN NOTAFISCAL.IDBLOQUEADO%TYPE DEFAULT NULL)
AS
   V_DTGRV         DATE;
   V_HRGRV         VARCHAR2(04);

   V_FILIAL        VARCHAR(10);
   V_NOVOCODIGO    INTEGER;
   V_NUMA          INTEGER;
   V_SEQPROD       VARCHAR2(04);
   V_ITEM          VARCHAR2(02);
   V_SERIE         VARCHAR2(03);
   V_WADOC         VARCHAR2(10);
   V_WASERIE       VARCHAR2(03);

   /* Variveis referente ao corpo da nota fiscal */
   V_BASEICMS      NUMBER;
   V_VALRICMS      NUMBER;
   V_BASEIPI       NUMBER;
   V_VALRIPI       NUMBER;
   V_BASEIRRF      NUMBER;
   V_VALRIRRF      NUMBER;
   V_BASEINSS      NUMBER;
   V_VALRINSS      NUMBER;
   V_VALRISS       NUMBER;
   V_BASEPIS       NUMBER;
   V_VALRPIS       NUMBER;
   V_VALRPISR      NUMBER;
   V_BASECOFINS    NUMBER;
   V_VALRCOFINS    NUMBER;
   V_VALRCOFINSR   NUMBER;
   V_BASECSLL      NUMBER;
   V_VALRCSLL      NUMBER;
   V_BASEPISST     NUMBER;
   V_VALRPISST     NUMBER;
   V_BASECOFINSST  NUMBER;
   V_VALRCOFINSST  NUMBER;

   /* Variveis referente aos itens da nota fiscal */
   V_VALRICMSIT    NUMBER;
   V_ALIQICMSIT    NUMBER;
   V_BASEICMSIT    NUMBER;
   V_VALRIPIIT     NUMBER;
   V_ALIQIPIIT     NUMBER;
   V_BASEIPIIT     NUMBER;
   V_VALRIRRFIT    NUMBER;
   V_ALIQIRRFIT    NUMBER;
   V_BASEIRRFIT    NUMBER;
   V_VALRISSIT     NUMBER;
   V_ALIQISSIT     NUMBER;
   V_BASEISSIT     NUMBER;
   V_VALRINSSIT    NUMBER;
   V_ALIQINSSIT    NUMBER;
   V_BASEINSSIT    NUMBER;
   V_BASEICMRETIT  NUMBER;
   V_VALRICMRETIT  NUMBER;
   V_BASEPISSTIT   NUMBER;
   V_VALRPISSTIT   NUMBER;
   V_ALIQPISSTIT   NUMBER;
   V_BASECOFSTIT   NUMBER;
   V_VALRCOFSTIT   NUMBER;
   V_ALIQCOFSTIT   NUMBER;
   V_VALRCSLLIT    NUMBER;
   V_ALIQCSLLIT    NUMBER;
   V_BASECSLLIT    NUMBER;
   V_VALRCOFIIT    NUMBER;
   V_ALIQCOFIIT    NUMBER;
   V_BASECOFIIT    NUMBER;
   V_VALRPISIT     NUMBER;
   V_ALIQPISIT     NUMBER;
   V_BASEPISIT     NUMBER;
   V_CUSTOITEM     NUMBER;
   V_VALDESC       NUMBER;
   V_PERCENT       NUMBER;
   V_VRDESCITEM    NUMBER;
   V_VRPRODUTOS    NUMBER;
   V_FORMPGTOAF    VARCHAR2(03);
BEGIN
   V_DTGRV := NULL;
   V_HRGRV := NULL;

   /* Retorna data e hora de exportao */
   BEGIN
      SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
      INTO V_DTGRV, V_HRGRV
      FROM DUAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DTGRV := NULL;
         V_HRGRV := NULL;
   END;

   /* Verificao dos documentos de Entrada */
   FOR C_ENTRADA IN (SELECT N.CDFILIAL,
                            N.NRLANCTONF,
                            N.CDFILIRECE,
                            N.DTENTRSAID,
                            LPAD(TRUNC(N.NRNOTAFISC),9,'0') NRNOTAFISC,
                            SUBSTR(N.CDSERIEENTR,1,3) AS CDSERIEENTR,
                            TO_DATE(N.DTEMISSAO) AS DTEMISSAO,
                            SUBSTR(replace(replace(replace(N.NRINSJURNF, '-', ''),'.',''),'/',''),1,14) AS NRINSJURFORN,
                            LPAD(FO.CDFORMPGTO,3,'0') AS CDFORMPGTO,
                            E.SGESTADO,
                            N.VRNOTAFISC,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '01') AS FRETE,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '06') AS DESPESA,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D', '02') AS DESCONTO,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'V', '07') AS BASICMSUBST,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '03') AS VRICMSUBST,
                            SUBSTR(T.CDEXTIPOOPER,1,2) AS CDEXTIPOOPER,
                            N.CDTIPOOPER,
                            SUBSTR(M.DSMODDOCFISC,1,INSTR(M.DSMODDOCFISC,'-')-1) AS ESPECIE,
                            N.NRACESSONFE
                       FROM NOTAFISCAL N, FORNECEDOR FO, ENDEFORN E, TIPOOPERAC T, FILIAL FI,
                            MODDOCFISC M,
                            (SELECT DISTINCT(FI.CDFILIAL), DTPROCESSA AS USR_DTFECHADIA
                               FROM FILGRUPFILI FI, PARAMFILIAL P
                              WHERE (FI.USR_IDPROTHEUS = 'S')
                                AND (FI.CDFILIAL = P.CDFILIAL)
                                AND (P_IDFECHA IS NULL)

                              UNION ALL

                             SELECT DISTINCT (FI.CDFILIAL), USR_DTFECHADIA
                               FROM FILGRUPFILI FI, USR_FECHAMENTO F
                              WHERE (FI.USR_IDPROTHEUS = 'S')
                                AND (P_IDFECHA = 'S')
                                AND (FI.CDFILIAL = F.USR_CDFILIAL)) FE
                      WHERE (N.IDENTRSAIDOP = 'E')
                        AND (N.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL)
                        AND (N.DTENTRSAID < USR_DTFECHADIA OR P_IDFECHA IS NULL)
                        AND (N.IDSISTEMA IN ('DFE','EST') OR N.IDSISTEMA IS NULL)
                        AND (N.USR_DTEXPORTACAO IS NULL)
                        AND (NOT N.NRNOTAFISC IS NULL)
                        AND (N.CDFORNECED = FO.CDFORNECED (+))
                        AND (E.CDFORNECED (+) = N.CDFORNECED)
                        AND (E.IDTPENDEFORN (+) = 'P')
                        AND (N.CDFILIEMIT = FI.CDFILIAL (+))
                        AND (T.IDENTRSAIDOP = N.IDENTRSAIDOP)
                        AND (T.CDTIPOOPER = N.CDTIPOOPER)
                        AND (M.CDMODDOCFISC = N.CDMODDOCFISC)
                        AND (N.CDFILIRECE = FE.CDFILIAL)
                        AND NOT EXISTS (SELECT CDFILIAL
                                          FROM NFRELACPEXOL O
                                         WHERE O.CDFILIAL = N.CDFILIAL
                                           AND O.NRLANCTONF = N.NRLANCTONF))
   LOOP
      V_BASEICMS     := 0;
      V_VALRICMS     := 0;
      V_BASEIPI      := 0;
      V_VALRIPI      := 0;
      V_BASEIRRF     := 0;
      V_VALRIRRF     := 0;
      V_BASEINSS     := 0;
      V_VALRINSS     := 0;
      V_VALRISS      := 0;
      V_BASEPIS      := 0;
      V_VALRPIS      := 0;
      V_VALRPISR     := 0;
      V_BASECOFINS   := 0;
      V_VALRCOFINS   := 0;
      V_VALRCOFINSR  := 0;
      V_BASECSLL     := 0;
      V_VALRCSLL     := 0;
      V_BASEPISST    := 0;
      V_VALRPISST    := 0;
      V_BASECOFINSST := 0;
      V_VALRCOFINSST := 0;
      V_VALRCSLLIT   := 0;
      V_ALIQCSLLIT   := 0;
      V_BASECSLLIT   := 0;
      V_VALRCOFIIT   := 0;
      V_ALIQCOFIIT   := 0;
      V_BASECOFIIT   := 0;
      V_VALRPISIT    := 0;
      V_ALIQPISIT    := 0;
      V_BASEPISIT    := 0;
      V_VRDESCITEM   := 0;
      V_VRPRODUTOS   := 0;

      V_SERIE        := NULL;

      SELECT MAX(CDGRUPFILI)
        INTO V_FILIAL
        FROM FILGRUPFILI
       WHERE CDFILIAL = C_ENTRADA.CDFILIRECE
         AND USR_IDPROTHEUS = 'S';

      IF NOT V_FILIAL IS NULL THEN

         IF SUBSTR(C_ENTRADA.CDSERIEENTR,1,1) <> '-' THEN
            V_SERIE := C_ENTRADA.CDSERIEENTR;
         END IF;


         BEGIN
            SELECT SUM(VRDESCITEM) AS VRDESCITEM,
                   SUM(VRTOTAITEM) AS VRPRODUTOS
              INTO V_VRDESCITEM, V_VRPRODUTOS
              FROM ITEMPRODUTO
             WHERE (CDFILIAL   = C_ENTRADA.CDFILIAL)
               AND (NRLANCTONF = C_ENTRADA.NRLANCTONF);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRDESCITEM := 0;
               V_VRPRODUTOS := 0;
         END;

         /* Valores referente a impostos */
         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEICMS, V_VALRICMS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '00';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEICMS := 0;
               V_VALRICMS := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEIPI, V_VALRIPI
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '10';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEIPI := 0;
               V_VALRIPI := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEIRRF, V_VALRIRRF
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '20';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEIRRF := 0;
               V_VALRIRRF := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEINSS, V_VALRINSS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '40';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEINSS := 0;
               V_VALRINSS := 0;
         END;

         BEGIN
            SELECT VRTOTIMPONF
              INTO V_VALRISS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '30';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VALRISS := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEPIS, V_VALRPIS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '50';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEPIS := 0;
               V_VALRPIS := 0;
         END;

         BEGIN
            SELECT VRTOTIMPONF
              INTO V_VALRPISR
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '51';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VALRPISR := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASECOFINS, V_VALRCOFINS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '60';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASECOFINS := 0;
               V_VALRCOFINS := 0;
         END;

         BEGIN
            SELECT VRTOTIMPONF
              INTO V_VALRCOFINSR
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '61';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VALRCOFINSR := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASECSLL, V_VALRCSLL
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '80';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASECSLL := 0;
               V_VALRCSLL := 0;
         END;

         /* PIS substituio tributria */
         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEPISST, V_VALRPISST
              FROM IMPOSNFTOT IM, IMPOSTO I
             WHERE I.CDIMPOSTO = '50'
               AND IM.CDFILIAL = C_ENTRADA.CDFILIAL
               AND IM.NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND IM.CDIMPOSTO = I.CDIMPOSTRIB;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEPISST := 0;
               V_VALRPISST := 0;
         END;

         /* COFINS substituio tributria */
         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASECOFINSST, V_VALRCOFINSST
              FROM IMPOSNFTOT IM, IMPOSTO I
             WHERE I.CDIMPOSTO = '60'
               AND IM.CDFILIAL = C_ENTRADA.CDFILIAL
               AND IM.NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND IM.CDIMPOSTO = I.CDIMPOSTRIB;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASECOFINSST := 0;
               V_VALRCOFINSST := 0;
         END;

         BEGIN
           SELECT LPAD(MAX(A.CDFORMPGTO),3,'0')
             INTO V_FORMPGTOAF
             FROM NFRELACAF R, AUTOFORNE A
            WHERE R.CDFILIAL = C_ENTRADA.CDFILIAL
              AND R.NRLANCTONF = C_ENTRADA.NRLANCTONF
              AND R.CDFILLANC = A.CDFILLANC
              AND R.CDFILDEST = A.CDFILDEST
              AND R.NRAUTOFORN = A.NRAUTOFORN;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_FORMPGTOAF := NULL;
         END;

         /* Verifica existncia da Nota Fiscal */
         SELECT NVL(MAX(WA_IDNFEC),0)
           INTO V_NUMA
           FROM USR_ZWA
          WHERE CDFILIAL = C_ENTRADA.CDFILIAL
            AND NRLANCTONF = C_ENTRADA.NRLANCTONF
            AND WA_TPEDI = '1';

         /* Retorna o sequencial para a tabela */
         BEGIN
            SELECT WA_IDNFEC.NEXTVAL
              INTO V_NOVOCODIGO
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NOVOCODIGO := 1;
         END;

         /* Se nao possui a nota fiscal sera incluido um novo registro */
         IF V_NUMA = 0 THEN
            /* Insere corpo de nota fiscal */
            INSERT INTO USR_ZWA
               (CDFILIAL, NRLANCTONF, WA_IDNFEC, WA_EMPRESA, WA_FILIAL, WA_DOC, WA_SERIE, WA_CGC, WA_EMISSAO, WA_EST,
                WA_FRETE, WA_DESPESA, WA_COND, WA_BASEICM, WA_VALICM, WA_BASEIPI, WA_VALIPI, WA_VALMERC, WA_VALBRUT, WA_TIPO,
                WA_DESCONT, WA_BRICMS, WA_ICMSRET, WA_IRRF, WA_FORMUL, WA_BASIMP4, WA_BASIMP5, WA_BASIMP6, WA_VALIMP4, WA_VALIMP5, WA_VALIMP6,
                WA_INSS, WA_ISS, WA_OPER,
                WA_ICMS, WA_BASEINS, WA_BASEIR,
                WA_VALPIS, WA_VALCOFI, WA_VALCSLL, WA_VALIRF, WA_BASEPS3,
                WA_VALPS3, WA_BASECF3, WA_VALCF3, WA_NFELETR, WA_ESPECIE, WA_DTDIGIT, WA_TPEDI, WA_DTGRV, WA_HRGRV, WA_VALDESC, FORMPGTOAF, NRACESSONFE)
            VALUES
               (C_ENTRADA.CDFILIAL, C_ENTRADA.NRLANCTONF, V_NOVOCODIGO, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), C_ENTRADA.NRNOTAFISC, V_SERIE, SUBSTR(C_ENTRADA.NRINSJURFORN,1,14) ,C_ENTRADA.DTEMISSAO, C_ENTRADA.SGESTADO,
                C_ENTRADA.FRETE, C_ENTRADA.DESPESA, C_ENTRADA.CDFORMPGTO, V_BASEICMS, V_VALRICMS, V_BASEIPI, V_VALRIPI, V_VRPRODUTOS, C_ENTRADA.VRNOTAFISC, 'N',
                C_ENTRADA.DESCONTO, ROUND(C_ENTRADA.BASICMSUBST,5), ROUND(C_ENTRADA.VRICMSUBST,5), V_VALRIRRF, 'N', 0, V_BASECOFINS, V_BASEPIS, 0, V_VALRCOFINS, V_VALRPIS,
                V_VALRINSS, V_VALRISS, C_ENTRADA.CDEXTIPOOPER,
                0, V_BASEINSS, V_BASEIRRF,
                V_VALRPISR, V_VALRCOFINSR, V_VALRCSLL, 0, V_BASEPISST,
                V_VALRPISST, V_BASECOFINSST, V_VALRCOFINSST, NULL, C_ENTRADA.ESPECIE, C_ENTRADA.DTENTRSAID, '1', V_DTGRV, V_HRGRV, (V_VRDESCITEM + C_ENTRADA.DESCONTO), V_FORMPGTOAF, C_ENTRADA.NRACESSONFE);
         ELSE
            SELECT NVL(MAX(WA_DOC),0), NVL(MAX(WA_SERIE),0)
              INTO V_WADOC, V_WASERIE
              FROM USR_ZWA
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND WA_IDNFEC = V_NUMA;
            /* Insere corpo de nota fiscal */
            INSERT INTO USR_ZWA
               (CDFILIAL, NRLANCTONF, WA_IDNFEC, WA_EMPRESA, WA_FILIAL, WA_DOC, WA_SERIE, WA_CGC, WA_EMISSAO, WA_EST,
                WA_FRETE, WA_DESPESA, WA_COND, WA_BASEICM, WA_VALICM, WA_BASEIPI, WA_VALIPI, WA_VALMERC, WA_VALBRUT, WA_TIPO,
                WA_DESCONT, WA_BRICMS, WA_ICMSRET, WA_IRRF, WA_FORMUL, WA_BASIMP4, WA_BASIMP5, WA_BASIMP6, WA_VALIMP4, WA_VALIMP5, WA_VALIMP6,
                WA_INSS, WA_ISS, WA_OPER,
                WA_ICMS, WA_BASEINS, WA_BASEIR,
                WA_VALPIS, WA_VALCOFI, WA_VALCSLL, WA_VALIRF, WA_BASEPS3,
                WA_VALPS3, WA_BASECF3, WA_VALCF3, WA_NFELETR, WA_ESPECIE, WA_DTDIGIT, WA_TPEDI, WA_DTGRV, WA_HRGRV, WA_VALDESC, FORMPGTOAF, NRACESSONFE)
            VALUES
               (C_ENTRADA.CDFILIAL, C_ENTRADA.NRLANCTONF, V_NOVOCODIGO, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), V_WADOC, V_WASERIE, SUBSTR(C_ENTRADA.NRINSJURFORN,1,14) ,C_ENTRADA.DTEMISSAO, C_ENTRADA.SGESTADO,
                C_ENTRADA.FRETE, C_ENTRADA.DESPESA, C_ENTRADA.CDFORMPGTO, V_BASEICMS, V_VALRICMS, V_BASEIPI, V_VALRIPI, V_VRPRODUTOS, C_ENTRADA.VRNOTAFISC, 'N',
                C_ENTRADA.DESCONTO, ROUND(C_ENTRADA.BASICMSUBST,5), ROUND(C_ENTRADA.VRICMSUBST,5), V_VALRIRRF, 'N', 0, V_BASECOFINS, V_BASEPIS, 0, V_VALRCOFINS, V_VALRPIS,
                V_VALRINSS, V_VALRISS, C_ENTRADA.CDEXTIPOOPER,
                0, V_BASEINSS, V_BASEIRRF,
                V_VALRPISR, V_VALRCOFINSR, V_VALRCSLL, 0, V_BASEPISST,
                V_VALRPISST, V_BASECOFINSST, V_VALRCOFINSST, NULL, C_ENTRADA.ESPECIE, C_ENTRADA.DTENTRSAID, '2', V_DTGRV, V_HRGRV, (V_VRDESCITEM + C_ENTRADA.DESCONTO), V_FORMPGTOAF, C_ENTRADA.NRACESSONFE);

            FOR C_ITEXCL IN (
               SELECT CDFILIAL, NRLANCTONF, WB_EMPRESA, WB_FILIAL, WB_DOC, WB_SERIE, WB_CGC, WB_EMISSAO,
                      WB_ITEM, WB_COD, WB_QUANT, WB_VUNIT, WB_TOTAL, WB_CC, WB_CF, WB_VALICM,
                      WB_VALIPI, WB_IPI, WB_PICM, WB_BASEICM, WB_BASEIPI, WB_ICMSRET, WB_BRICMS, WB_DESC,
                      WB_ICMSCOM, WB_TIPO, WB_FORMUL, WB_CLASFIS, WB_BASIMP4, WB_BASIMP5, WB_BASIMP6,
                      WB_VALIMP4, WB_VALIMP5, WB_VALIMP6,
                      WB_BASEIRR, WB_ALIQIRR, WB_VALIRR, WB_BASEISS, WB_ALIQISS, WB_VALISS, WB_BASEINS,
                      WB_ALIQINS, WB_VALINS, WB_ALIQCF3, WB_VALCF3, WB_VALPS3, WB_BASECF3, WB_BASEPS3,
                      WB_ALIQPS3, WB_CUSTO, WB_DTDIGIT, WB_VALDESC
                 FROM USR_ZWB
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND WB_IDNFEI = V_NUMA) LOOP

               /* Insere itens da nota fiscal */
               INSERT INTO USR_ZWB
                  (CDFILIAL, NRLANCTONF, WB_IDNFEI, WB_EMPRESA, WB_FILIAL, WB_DOC, WB_SERIE, WB_CGC, WB_EMISSAO,
                   WB_ITEM, WB_COD, WB_QUANT, WB_VUNIT, WB_TOTAL, WB_CC, WB_CF, WB_VALICM,
                   WB_VALIPI, WB_IPI, WB_PICM, WB_BASEICM, WB_BASEIPI, WB_ICMSRET, WB_BRICMS, WB_DESC,
                   WB_ICMSCOM, WB_TIPO, WB_FORMUL, WB_CLASFIS, WB_BASIMP4, WB_BASIMP5, WB_BASIMP6,
                   WB_VALIMP4, WB_VALIMP5, WB_VALIMP6,
                   WB_BASEIRR, WB_ALIQIRR, WB_VALIRR, WB_BASEISS, WB_ALIQISS, WB_VALISS, WB_BASEINS,
                   WB_ALIQINS, WB_VALINS, WB_ALIQCF3, WB_VALCF3, WB_VALPS3, WB_BASECF3, WB_BASEPS3,
                   WB_ALIQPS3, WB_CUSTO, WB_DTDIGIT, WB_TPEDI, WB_DTGRV, WB_HRGRV, WB_VALDESC)
               VALUES
                  (C_ITEXCL.CDFILIAL, C_ITEXCL.NRLANCTONF, V_NOVOCODIGO, C_ITEXCL.WB_EMPRESA, C_ITEXCL.WB_FILIAL, C_ITEXCL.WB_DOC, C_ITEXCL.WB_SERIE, C_ITEXCL.WB_CGC, C_ITEXCL.WB_EMISSAO,
                   C_ITEXCL.WB_ITEM, C_ITEXCL.WB_COD, C_ITEXCL.WB_QUANT, C_ITEXCL.WB_VUNIT, C_ITEXCL.WB_TOTAL, C_ITEXCL.WB_CC, C_ITEXCL.WB_CF, C_ITEXCL.WB_VALICM,
                   C_ITEXCL.WB_VALIPI, C_ITEXCL.WB_IPI, C_ITEXCL.WB_PICM, C_ITEXCL.WB_BASEICM, C_ITEXCL.WB_BASEIPI, C_ITEXCL.WB_ICMSRET, C_ITEXCL.WB_BRICMS, C_ITEXCL.WB_DESC,
                   C_ITEXCL.WB_ICMSCOM, C_ITEXCL.WB_TIPO, C_ITEXCL.WB_FORMUL, C_ITEXCL.WB_CLASFIS, C_ITEXCL.WB_BASIMP4, C_ITEXCL.WB_BASIMP5, C_ITEXCL.WB_BASIMP6,
                   C_ITEXCL.WB_VALIMP4, C_ITEXCL.WB_VALIMP5, C_ITEXCL.WB_VALIMP6,
                   C_ITEXCL.WB_BASEIRR, C_ITEXCL.WB_ALIQIRR, C_ITEXCL.WB_VALIRR, C_ITEXCL.WB_BASEISS, C_ITEXCL.WB_ALIQISS, C_ITEXCL.WB_VALISS, C_ITEXCL.WB_BASEINS,
                   C_ITEXCL.WB_ALIQINS, C_ITEXCL.WB_VALINS, C_ITEXCL.WB_ALIQCF3, C_ITEXCL.WB_VALCF3, C_ITEXCL.WB_VALPS3, C_ITEXCL.WB_BASECF3, C_ITEXCL.WB_BASEPS3,
                   C_ITEXCL.WB_ALIQPS3, C_ITEXCL.WB_CUSTO, C_ITEXCL.WB_DTDIGIT, '2', V_DTGRV, V_HRGRV, C_ITEXCL.WB_VALDESC);
            END LOOP;

            FOR C_RATEXCL IN (
               SELECT CDFILIAL, NRLANCTONF, WH_IDREDZ, WH_ITEMNF, WH_ITEM, WH_EMPRESA, WH_FILIAL, WH_DOC,
                   WH_SERIE, WH_CGC, WH_PERC, WH_CC, WH_CUSTO1
                 FROM USR_ZWH
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND WH_IDREDZ = V_NUMA) LOOP

               INSERT INTO USR_ZWH
                  (CDFILIAL, NRLANCTONF, WH_IDREDZ, WH_ITEMNF, WH_ITEM, WH_EMPRESA, WH_FILIAL, WH_DOC,
                   WH_SERIE, WH_CGC, WH_PERC, WH_CC, WH_CUSTO1, WH_TPEDI, WH_DTGRV, WH_HRGRV)
               VALUES
                  (C_RATEXCL.CDFILIAL, C_RATEXCL.NRLANCTONF, V_NOVOCODIGO, C_RATEXCL.WH_ITEMNF, C_RATEXCL.WH_ITEM, C_RATEXCL.WH_EMPRESA, C_RATEXCL.WH_FILIAL, C_RATEXCL.WH_DOC,
                   C_RATEXCL.WH_SERIE, C_RATEXCL.WH_CGC, C_RATEXCL.WH_PERC, C_RATEXCL.WH_CC, C_RATEXCL.WH_CUSTO1, '2', V_DTGRV, V_HRGRV);
            END LOOP;

            /* Retorna o sequencial para a tabela */
            BEGIN
               SELECT WA_IDNFEC.NEXTVAL
                 INTO V_NOVOCODIGO
                 FROM DUAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_NOVOCODIGO := 1;
            END;

            /* Insere corpo de nota fiscal */
            INSERT INTO USR_ZWA
               (CDFILIAL, NRLANCTONF, WA_IDNFEC, WA_EMPRESA, WA_FILIAL, WA_DOC, WA_SERIE, WA_CGC, WA_EMISSAO, WA_EST,
                WA_FRETE, WA_DESPESA, WA_COND, WA_BASEICM, WA_VALICM, WA_BASEIPI, WA_VALIPI, WA_VALMERC, WA_VALBRUT, WA_TIPO,
                WA_DESCONT, WA_BRICMS, WA_ICMSRET, WA_IRRF, WA_FORMUL, WA_BASIMP4, WA_BASIMP5, WA_BASIMP6, WA_VALIMP4, WA_VALIMP5, WA_VALIMP6,
                WA_INSS, WA_ISS, WA_OPER,
                WA_ICMS, WA_BASEINS, WA_BASEIR,
                WA_VALPIS, WA_VALCOFI, WA_VALCSLL, WA_VALIRF, WA_BASEPS3,
                WA_VALPS3, WA_BASECF3, WA_VALCF3, WA_NFELETR, WA_ESPECIE, WA_DTDIGIT, WA_TPEDI, WA_DTGRV, WA_HRGRV, WA_VALDESC, FORMPGTOAF, NRACESSONFE)
            VALUES
               (C_ENTRADA.CDFILIAL, C_ENTRADA.NRLANCTONF, V_NOVOCODIGO, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), C_ENTRADA.NRNOTAFISC, V_SERIE,SUBSTR(C_ENTRADA.NRINSJURFORN,1,14) ,C_ENTRADA.DTEMISSAO, C_ENTRADA.SGESTADO,
                C_ENTRADA.FRETE, C_ENTRADA.DESPESA, C_ENTRADA.CDFORMPGTO, V_BASEICMS, V_VALRICMS, V_BASEIPI, V_VALRIPI, V_VRPRODUTOS, C_ENTRADA.VRNOTAFISC, 'N',
                C_ENTRADA.DESCONTO, ROUND(C_ENTRADA.BASICMSUBST,5), ROUND(C_ENTRADA.VRICMSUBST,5), V_VALRIRRF, 'N', 0, V_BASECOFINS, V_BASEPIS, 0, V_VALRCOFINS, V_VALRPIS,
                V_VALRINSS, V_VALRISS, C_ENTRADA.CDEXTIPOOPER,
                0, V_BASEINSS, V_BASEIRRF,
                V_VALRPISR, V_VALRCOFINSR, V_VALRCSLL, 0, V_BASEPISST,
                V_VALRPISST, V_BASECOFINSST, V_VALRCOFINSST, NULL, C_ENTRADA.ESPECIE, C_ENTRADA.DTENTRSAID, '1', V_DTGRV, V_HRGRV, (V_VRDESCITEM + C_ENTRADA.DESCONTO), V_FORMPGTOAF, C_ENTRADA.NRACESSONFE);
         END IF;

         /* Verificao dos itens da nota fiscal */
         FOR C_ITEMENTRADA IN (SELECT I.NRSEQITPROD, P.CDARVPROD, I.QTITEMPROD, I.VRUNITITEM, I.CDFISOPEITEM,
                                      I.VRTOTAITEM, I.VRDESCITEM, I.CDSITUTRIBPR, I.VRCONTITEM, T.TOTALITEM
                                 FROM ITEMPRODUTO I, PRODUTO P,
                                      (SELECT SUM(VRTOTAITEM) AS TOTALITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                                          AND NRLANCTONF = C_ENTRADA.NRLANCTONF) T
                                WHERE I.CDFILIAL = C_ENTRADA.CDFILIAL
                                  AND I.NRLANCTONF = C_ENTRADA.NRLANCTONF
                                  AND I.CDPRODUTO = P.CDPRODUTO
                              )
         LOOP
            V_VALRICMSIT   := 0;
            V_ALIQICMSIT   := 0;
            V_BASEICMSIT   := 0;
            V_VALRIPIIT    := 0;
            V_ALIQIPIIT    := 0;
            V_BASEIPIIT    := 0;
            V_VALRIRRFIT   := 0;
            V_ALIQIRRFIT   := 0;
            V_BASEIRRFIT   := 0;
            V_VALRISSIT    := 0;
            V_ALIQISSIT    := 0;
            V_BASEISSIT    := 0;
            V_VALRINSSIT   := 0;
            V_ALIQINSSIT   := 0;
            V_BASEINSSIT   := 0;
            V_BASEICMRETIT := 0;
            V_VALRICMRETIT := 0;
            V_BASEPISSTIT  := 0;
            V_VALRPISSTIT  := 0;
            V_ALIQPISSTIT  := 0;
            V_BASECOFSTIT  := 0;
            V_VALRCOFSTIT  := 0;
            V_ALIQCOFSTIT  := 0;
            V_CUSTOITEM    := 0;
            V_VALDESC      := ROUND(C_ITEMENTRADA.VRDESCITEM + ((C_ITEMENTRADA.VRTOTAITEM / C_ITEMENTRADA.TOTALITEM) * C_ENTRADA.DESCONTO),2);
            IF (V_VRDESCITEM + C_ENTRADA.DESCONTO) > 0 THEN
               V_PERCENT      := ROUND((V_VALDESC * 100) / (V_VRDESCITEM + C_ENTRADA.DESCONTO),2);
            ELSE
               V_PERCENT      := 0;
            END IF;

            /* Valores referente a impostos */
            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRICMSIT, V_ALIQICMSIT, V_BASEICMSIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '00'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRICMSIT := 0;
                  V_ALIQICMSIT := 0;
                  V_BASEICMSIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRIPIIT, V_ALIQIPIIT, V_BASEIPIIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '10'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRIPIIT := 0;
                  V_ALIQIPIIT := 0;
                  V_BASEIPIIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRIRRFIT, V_ALIQIRRFIT, V_BASEIRRFIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '20'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRIRRFIT := 0;
                  V_ALIQIRRFIT := 0;
                  V_BASEIRRFIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRISSIT, V_ALIQISSIT, V_BASEISSIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '30'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRISSIT := 0;
                  V_ALIQISSIT := 0;
                  V_BASEISSIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRINSSIT, V_ALIQINSSIT, V_BASEINSSIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '40'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRINSSIT := 0;
                  V_ALIQINSSIT := 0;
                  V_BASEINSSIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRCSLLIT, V_ALIQCSLLIT, V_BASECSLLIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '80'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRCSLLIT := 0;
                  V_ALIQCSLLIT := 0;
                  V_BASECSLLIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRCOFIIT, V_ALIQCOFIIT, V_BASECOFIIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '60'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRCOFIIT := 0;
                  V_ALIQCOFIIT := 0;
                  V_BASECOFIIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRPISIT, V_ALIQPISIT, V_BASEPISIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '50'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRPISIT := 0;
                  V_ALIQPISIT := 0;
                  V_BASEPISIT := 0;
            END;

            /* PIS substituio tributria */
            BEGIN
               SELECT VRBASECALCIT, VRIMPOSTOIT, VRALIQITEM
                 INTO V_BASEPISSTIT, V_VALRPISSTIT, V_ALIQPISSTIT
                 FROM ITEMPROIMPOS IM, IMPOSTO I
                WHERE I.CDIMPOSTO = '50'
                  AND IM.CDFILIAL = C_ENTRADA.CDFILIAL
                  AND IM.NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND IM.NRITPROIMPOS = '1'
                  AND IM.CDIMPOSTO = I.CDIMPOSTRIB;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_BASEPISSTIT := 0;
                  V_VALRPISSTIT := 0;
                  V_ALIQPISSTIT := 0;
            END;

            /* COFINS substituio tributria */
            BEGIN
               SELECT VRBASECALCIT, VRIMPOSTOIT, VRALIQITEM
                 INTO V_BASECOFSTIT, V_VALRCOFSTIT, V_ALIQCOFSTIT
                 FROM ITEMPROIMPOS IM, IMPOSTO I
                WHERE I.CDIMPOSTO = '60'
                  AND IM.CDFILIAL = C_ENTRADA.CDFILIAL
                  AND IM.NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND IM.NRITPROIMPOS = '1'
                  AND IM.CDIMPOSTO = I.CDIMPOSTRIB;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_BASECOFSTIT := 0;
                  V_VALRCOFSTIT := 0;
                  V_ALIQCOFSTIT := 0;
            END;

            V_BASEICMRETIT := ((C_ITEMENTRADA.VRTOTAITEM / C_ITEMENTRADA.TOTALITEM) * C_ENTRADA.BASICMSUBST);
            V_VALRICMRETIT := ((C_ITEMENTRADA.VRTOTAITEM / C_ITEMENTRADA.TOTALITEM) * C_ENTRADA.VRICMSUBST);

            V_CUSTOITEM := C_ITEMENTRADA.VRCONTITEM;

            IF (C_ITEMENTRADA.VRTOTAITEM <> C_ITEMENTRADA.VRCONTITEM) THEN
               IF (ABS(C_ITEMENTRADA.VRTOTAITEM - (C_ITEMENTRADA.VRCONTITEM + V_VALRCOFIIT + V_VALRPISIT)) < 0.01) THEN
                  V_CUSTOITEM := (C_ITEMENTRADA.VRTOTAITEM - (V_VALRCOFIIT + V_VALRPISIT));
               END IF;
            END IF;

            /* Insere itens da nota fiscal */
            INSERT INTO USR_ZWB
               (CDFILIAL, NRLANCTONF, WB_IDNFEI, WB_EMPRESA, WB_FILIAL, WB_DOC, WB_SERIE, WB_CGC, WB_EMISSAO,
                WB_ITEM, WB_COD, WB_QUANT, WB_VUNIT, WB_TOTAL, WB_CC, WB_CF, WB_VALICM,
                WB_VALIPI, WB_IPI, WB_PICM, WB_BASEICM, WB_BASEIPI, WB_ICMSRET, WB_BRICMS, WB_DESC,
                WB_ICMSCOM, WB_TIPO, WB_FORMUL, WB_CLASFIS, WB_BASIMP4, WB_BASIMP5, WB_BASIMP6,
                WB_VALIMP4, WB_VALIMP5, WB_VALIMP6,
                WB_BASEIRR, WB_ALIQIRR, WB_VALIRR, WB_BASEISS, WB_ALIQISS, WB_VALISS, WB_BASEINS,
                WB_ALIQINS, WB_VALINS, WB_ALIQCF3, WB_VALCF3, WB_VALPS3, WB_BASECF3, WB_BASEPS3,
                WB_ALIQPS3, WB_CUSTO, WB_DTDIGIT, WB_TPEDI, WB_DTGRV, WB_HRGRV, WB_VALDESC)
            VALUES
               (C_ENTRADA.CDFILIAL, C_ENTRADA.NRLANCTONF, V_NOVOCODIGO, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), C_ENTRADA.NRNOTAFISC, V_SERIE, SUBSTR(C_ENTRADA.NRINSJURFORN,1,14), C_ENTRADA.DTEMISSAO,
                C_ITEMENTRADA.NRSEQITPROD, SUBSTR(C_ITEMENTRADA.CDARVPROD,1,15), C_ITEMENTRADA.QTITEMPROD, C_ITEMENTRADA.VRUNITITEM,
                C_ITEMENTRADA.VRTOTAITEM, C_ENTRADA.CDFILIRECE, SUBSTR(C_ITEMENTRADA.CDFISOPEITEM,1,5), V_VALRICMSIT,
                V_VALRIPIIT, V_ALIQIPIIT, V_ALIQICMSIT, V_BASEICMSIT, V_BASEIPIIT, ROUND(V_VALRICMRETIT,5), ROUND(V_BASEICMRETIT,5), V_PERCENT,
                0, 'N', 'N', C_ITEMENTRADA.CDSITUTRIBPR, 0, V_BASECOFIIT, V_BASEPISIT,
                0, V_VALRCOFIIT, V_VALRPISIT,
                V_BASEIRRFIT, V_ALIQIRRFIT, V_VALRIRRFIT, V_BASEISSIT, V_ALIQISSIT, V_VALRISSIT,
                V_BASEINSSIT, V_ALIQINSSIT, V_VALRINSSIT,
                V_ALIQCOFSTIT, V_VALRCOFSTIT, V_VALRPISSTIT, V_BASECOFSTIT, V_BASEPISSTIT,
                V_ALIQPISSTIT, V_CUSTOITEM, C_ENTRADA.DTENTRSAID, '1', V_DTGRV, V_HRGRV, V_VALDESC);
         END LOOP;

         V_SEQPROD := NULL;
         V_ITEM    := '00';

         /* Verificao rateios contbeis por produto */
         FOR C_RATEPROD IN (SELECT R.NRSEQITPROD, R.CDFILICCUST, R.CDCENTCUSNF, T.VRRATETOT, SUM(VRRATENF) AS VRRATENF
                              FROM RATEIONF R,
                                  (SELECT NRSEQITPROD, SUM(VRRATENF) AS VRRATETOT
                                     FROM RATEIONF
                                    WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                                      AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                                    GROUP BY NRSEQITPROD) T
                             WHERE R.CDFILIAL = C_ENTRADA.CDFILIAL
                               AND R.NRLANCTONF = C_ENTRADA.NRLANCTONF
                               AND R.NRSEQITPROD = T.NRSEQITPROD
                             GROUP BY R.NRSEQITPROD, R.CDFILICCUST, R.CDCENTCUSNF, T.VRRATETOT
                             ORDER BY R.NRSEQITPROD, R.CDFILICCUST, R.CDCENTCUSNF
                           )
         LOOP
            IF C_RATEPROD.NRSEQITPROD <> V_SEQPROD THEN
               V_ITEM := '01';
            ELSE
               V_ITEM := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_ITEM) + 1)),2,'0');
            END IF;

            /* Insere rateio contabil de produtos */
            INSERT INTO USR_ZWH
               (CDFILIAL, NRLANCTONF, WH_IDREDZ, WH_ITEMNF, WH_ITEM, WH_EMPRESA, WH_FILIAL, WH_DOC,
                WH_SERIE, WH_CGC, WH_PERC, WH_CC, WH_CUSTO1, WH_TPEDI, WH_DTGRV, WH_HRGRV)
            VALUES
               (C_ENTRADA.CDFILIAL, C_ENTRADA.NRLANCTONF, V_NOVOCODIGO, C_RATEPROD.NRSEQITPROD, V_ITEM,
                SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), C_ENTRADA.NRNOTAFISC,
                V_SERIE, SUBSTR(C_ENTRADA.NRINSJURFORN,1,14), ROUND(((100 * C_RATEPROD.VRRATENF) / C_RATEPROD.VRRATETOT),2), C_RATEPROD.CDFILICCUST,
                C_RATEPROD.VRRATENF, '1', V_DTGRV, V_HRGRV);

             V_SEQPROD := C_RATEPROD.NRSEQITPROD;
         END LOOP;

         /* Inclui a data de exportao para os documentos exportados*/
         UPDATE NOTAFISCAL
            SET USR_DTEXPORTACAO = V_DTGRV
          WHERE CDFILIAL = C_ENTRADA.CDFILIAL
            AND NRLANCTONF = C_ENTRADA.NRLANCTONF;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_NF_ENTRADA_OFICIAL','5.50.XXX'); END;
/


