CREATE OR REPLACE 
TRIGGER BLOQUEIA_PONTO
BEFORE INSERT OR UPDATE OR DELETE ON PONTO FOR EACH ROW
DECLARE
   V_DTFECHAMENTO_PERIODO PONTO.DTHRPONTO%TYPE;
   V_DTPONTO PONTO.DTHRPONTO%TYPE;
   V_CDEMPRESA PONTO.CDEMPRESA%TYPE;
   V_CDFUNC PONTO.CDFUNC%TYPE;
BEGIN
   IF INSERTING OR UPDATING THEN
      V_DTPONTO := :NEW.DTHRPONTO;
      V_CDEMPRESA := :NEW.CDEMPRESA;
      V_CDFUNC := :NEW.CDFUNC;
   END IF;
   IF DELETING THEN
      V_DTPONTO := :OLD.DTHRPONTO;
      V_CDEMPRESA := :OLD.CDEMPRESA;
      V_CDFUNC := :OLD.CDFUNC;
   END IF;
   BEGIN
      SELECT CASE 
             WHEN (F.CDTPADMISSAO <> 'P') AND (TO_CHAR(V_DTPONTO, 'DD') >= '21') AND (TO_CHAR(V_DTPONTO, 'DD') <= '31')
             THEN ADD_MONTHS(TO_DATE('20/'||TO_CHAR(V_DTPONTO, 'MM/YYYY')), 1)
             WHEN (F.CDTPADMISSAO <> 'P') AND (TO_CHAR(V_DTPONTO, 'DD') >= '01') AND (TO_CHAR(V_DTPONTO, 'DD') <= '20')
             THEN TO_DATE('20/'||TO_CHAR(V_DTPONTO, 'MM/YYYY'))
             WHEN (F.CDTPADMISSAO = 'P') AND (TO_CHAR(V_DTPONTO, 'DD') >= '27') AND (TO_CHAR(V_DTPONTO, 'DD') <= '31')
             THEN ADD_MONTHS(TO_DATE('26/'||TO_CHAR(V_DTPONTO, 'MM/YYYY')), 1)
             WHEN (F.CDTPADMISSAO = 'P') AND (TO_CHAR(V_DTPONTO, 'DD') >= '01') AND (TO_CHAR(V_DTPONTO, 'DD') <= '26')
             THEN TO_DATE('26/'||TO_CHAR(V_DTPONTO, 'MM/YYYY'))
              END AS DTFECHAMENTO_PERIODO
        INTO V_DTFECHAMENTO_PERIODO           
        FROM FUNCIONARIO F
       WHERE F.CDEMPRESA = V_CDEMPRESA
         AND F.CDFUNC = V_CDFUNC ;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN V_DTFECHAMENTO_PERIODO := NULL;
   END;
   IF (V_DTFECHAMENTO_PERIODO IS NOT NULL) AND (TRUNC(SYSDATE) > V_DTFECHAMENTO_PERIODO + 15) THEN
      RAISE_APPLICATION_ERROR(-20501, 'OPERAO BLOQUEADA!!! PERODO DE APURAO DE PONTO FECHADO E BLOQUEADO PARA QUALQUER TIPO DE MANUTENO.', True);
   END IF;
END;
/
